from abstract.ofcchart.ofc import *
from Products.CMFCore.utils import getToolByName
from AccessControl import ClassSecurityInfo
from Products.Five import BrowserView

class OFCChartView(BrowserView):
    """ docstring """
    security = ClassSecurityInfo()

    def __init__(self, context, request):
        """ docstring """
        self.context = context
        self.request = request

    def encodeData(self):
        """ docstring """
        data = self.request.get('values',None)
        x_labels = self.request.get('x_labels',None)
        return "?values=%s&amp;x_labels=%s" % ( data, x_labels )
        g = GraphData()

        # we add 3 sets of data:
        g.set_data( data.split(',') )

        # we add the 3 line types and key labels
        g.line( 2, '0x9933CC', 'Page views', 10 )
        g.line_dot( 3, 5, '0xCC3399', 'Downloads', 10)    # <-- 3px thick + dots
        g.line_hollow( 2, 4, '0x80a033', 'Bounces', 10 )
        g.set_x_labels( x_labels )
        g.set_x_label_style( 10, '0x000000', 0, 2 )

        g.set_y_max( 20 )
        g.y_label_steps( 4 )
        g.set_y_legend( 'Open Flash Chart Python', 12, '0x736AFF' )
        return g.render()

    def ofc_render(self):
        """ docstring """
        request = self.request
        context = self.context
        portal = getToolByName( context, 'portal_url').getPortalObject()
        catalog = getToolByName( context, 'portal_catalog')

        g = GraphObject()
        
        w = self.context.getWidth()
        h = self.context.getHeight()
        
        return g.render(width=w, height=h, data_url=self.context.absolute_url()+'/@@chart/generateChartValues'+self.encodeData(), ofc_base_url=portal.absolute_url()+'/', ofc_swf="open-flash-chart.swf" )

    def generateChartValues(self):
        """
            create chart from values
        """
        ctype = self.context.getChart_type()
        values = self.context.getValues()
        title = self.context.Title()
        ylegend = self.context.getYlegend()
        xlegend = self.context.getXlegend()
        lname = self.context.getLname()

        if ctype == "Data Lines":
            line_labels = "x_labels="
            line_values = "values="
            url = ""
            vmin = 65536
            vmax = -65536
            for v in values:
                try:
                    val = float(v['value'])
                    if val >= vmax:
                        vmax = val
                    if val <= vmin:
                        vmin = val
                    line_labels = line_labels + v['label'] + ','
                    line_values = line_values + str(val) + ','
                except:
                    pass
            line_labels = line_labels[:-1]
            line_values = line_values[:-1]
            vmin = vmin - 5
            vmax = vmax + 5
            url = "&title=" + title + ",{font-size:20px; color: #FFFFFF; margin: 5px; background-color: #505050; padding:5px; padding-left: 20px; padding-right: 20px;}&x_label_style=10,0x000000,0,1&x_axis_steps=1&y_legend=" + ylegend + ",12,#736AFF&x_legend=" + xlegend + ",12,#736AFF&y_ticks=1,10,4&line=2,0x9933CC," + lname + ",10&" + line_values + "&" + line_labels + "&y_min=" + str(vmin) + "&y_max=" + str(vmax) + "&"
        if ctype == "Bar Chart":
            line_labels = "x_labels="
            line_values = "values="
            url = ""
            vmin = 65536
            vmax = -65536
            for v in values:
                try:
                    val = float(v['value'])
                    if val >= vmax:
                        vmax = val
                    if val <= vmin:
                        vmin = val
                    line_labels = line_labels + v['label'] + ','
                    line_values = line_values + str(val) + ','
                except:
                    pass
            line_labels = line_labels[:-1]
            line_values = line_values[:-1]
            vmin = vmin - 5
            vmax = vmax + 5
            url = "&title=" + title + ",{font-size:20px; color: #FFFFFF; margin: 5px; background-color: #505050; padding:5px; padding-left: 20px; padding-right: 20px;}&x_label_style=10,#9933CC,0,1&x_axis_steps=1&y_legend=" + ylegend + ",12,#736AFF&x_legend=" + xlegend + ",12,#736AFF&y_ticks=1,10,4&" + line_values + "&" + line_labels + "&y_min=" + str(vmin) + "&y_max=" + str(vmax) + "&filled_bar=50,#9933CC,#8010A0," + lname + ",10&"
        if ctype == "3D Bar Chart":
            line_labels = "x_labels="
            line_values = "values="
            vmin = 65536
            vmax = -65536
            url = ""
            for v in values:
                try:
                    val = float(v['value'])
                    if val >= vmax:
                        vmax = val
                    if val <= vmin:
                        vmin = val
                    line_labels = line_labels + v['label'] + ','
                    line_values = line_values + str(val) + ','
                except:
                    pass
            line_labels = line_labels[:-1]
            line_values = line_values[:-1]
            vmin = vmin - 5
            vmax = vmax + 5
            url = "&title=" + title + ",{font-size:20px; color: #FFFFFF; margin: 5px; background-color: #505050; padding:5px; padding-left: 20px; padding-right: 20px;}&x_label_style=10,#9933CC,0,1&x_axis_3d=12&x_axis_steps=1&y_legend=" + ylegend + ",12,#736AFF&x_legend=" + xlegend + ",12,#736AFF&y_ticks=1,10,4&" + line_values + "&" + line_labels + "&y_min=" + str(vmin) + "&y_max=" + str(vmax) + "&x_axis_colour=#909090&x_grid_colour=#ADB5C7&y_axis_colour=#909090&y_grid_colour=#ADB5C7&bar_3d=75,#D54C78," + lname + ",10&"
        if ctype == 'Pie Chart':
            line_labels = "pie_labels="
            line_values = "values="
            line_colors = "colours="
            url = ""
            vmin = 65536
            vmax = -65536
            colors = ['#d01f3c','#356aa0','#C79810', '#FF8800', '#505050', '#0099CC', '#990000', '#CCFF66', '#66CC66', '#330066']
            c = 0
            tot = 0
            for v in values:
                try:
                    val = float(v['value'])
                except:
                    #if v['value'] is not a Integer or Float value
                    val = 0.0
                if val >= vmax:
                    vmax = val
                if val <= vmin:
                    vmin = val
                tot = tot + val
            for v in values:
                try:
                    val = float(v['value'])
                    line_labels = line_labels + v['label'] + ','
                    perc = (val * 100)/tot
                    line_values = line_values + str(perc) + ','
                    ind = c % 10
                    line_colors = line_colors + colors[ind] + ','
                    c += 1
                except:
                    #if v['value'] is not a Integer or Float value
                    pass
            line_labels = line_labels[:-1]
            line_values = line_values[:-1]
            line_colors = line_colors[:-1]
            vmin = vmin - 5
            vmax = vmax + 5
            url = "&title=" + title + ",{font-size:20px; color: #FFFFFF; margin: 5px; background-color: #505050; padding:5px; padding-left: 20px; padding-right: 20px;}&x_axis_steps=1&y_ticks=1,10,5&line=3,#87421F&y_min=" + str(vmin) + "&y_max=" + str(vmax) + "&pie=60,#505050,{font-size: 12px; color: #404040;}&" + line_values + "&" + line_labels + "&" + line_colors + "&links=&tool_tip=%23val%23%25&"
        return url